
%            +------------------------------------------+
%            |                 fatti                    |
%            +------------------------------------------+


character(priam, iliad).
character(hecuba, iliad).
character(achilles, iliad).
character(agamemnon, iliad).
character(patroclus, iliad).
character(hector, iliad).
character(andromache, iliad).
character(rhesus, iliad).
character(ulysses, iliad).
character(menelaus, iliad).
character(helen, iliad).
character(ulysses, odyssey).
character(penelope, odyssey).
character(telemachus, odyssey).
character(laertes, odyssey).
character(nestor, odyssey).
character(menelaus, odyssey).
character(helen, odyssey).
character(hermione, odyssey).

female(penelope).
female(helen).
female(andromache).
female(hecuba).
male(priam).
male(achilles).
male(agamemnon).
male(patroclus).
male(hector).
male(rhesus).
male(ulysses).
male(menelaus).
male(telemachus).
male(laertes).
male(nestor).

father(priam, hector).
father(laertes,ulysses).
father(atreus,menelaus).
father(menelaus, hermione).
father(ulysses, telemachus).

mother(hecuba, hector).
mother(penelope,telemachus).
mother(helen, hermione).

king(ulysses, ithaca, achaean).
king(menelaus, sparta, achaean).
king(nestor, pylos, achaean).
king(agamemnon, argos, achaean).
king(priam, troy, trojan).
king(rhesus, thrace, trojan).

character(priam, iliad, king(troy, trojan)).
character(ulysses, iliad, king(ithaca, achaean)).
character(menelaus, iliad, king(sparta, achaean)).

%            +------------------------------------------+
%            |           esempio di ricerca             |
%            +------------------------------------------+

trova-character(X):-
         character(X,Y),
         write('Il prsonaggio '),
         write(X),
         write('  presente in '),
         write(Y).
%          !;
%          write('Il personaggio non esiste'),
%          !.
         
%            +------------------------------------------+
%            |           variabili condivise            |
%            +------------------------------------------+


%        king(X, ithaca, Y), father(X, Z).
        
%            +------------------------------------------+
%            |           esempio di regola              |
%            +------------------------------------------+
        
son(X, Y):-
       father(Y, X), male(X).
son(X, Y):-
       mother(Y, X), male(X).
       
genitori(Genitori, Figlio):-
        father(Padre, Figlio),
        mother(Madre, Figlio),
        Genitori = Padre-Madre.
        
%            +------------------------------------------+
%            |          nonni e antenati                |
%            +------------------------------------------+
        
        
parent(X, Y) :- mother(X, Y).
parent(X, Y) :- father(X, Y).

grandparent(Nonno, Nipote) :-
                           parent(Nonno, Figlio), parent(Figlio, Nipote).

% ricorsione
ancestor(X, Y) :- parent(X, Y).
ancestor(X, Y) :- parent(X, Z), ancestor(Z, Y).

% ancestor(X, telemachus).


%            +------------------------------------------+
%            |               le stringhe                |
%            +------------------------------------------+


stringa:-
       Frase = 'Sono scesi in molti dalle case strette e alte di questa che fu la Suburra romana per dare l\'ultimo saluto al grande regista Monicelli',
       atom_codes(Frase, Codes),
       string_to_atom(Codes,Atom),
       writeln('IL VALORE DELLA VARIABILE <FRASE>:'),
       writeln(Frase),nl,
       writeln('FRASE TRASFORMATA IN STRINGA:'),
       writeln(Codes),nl,
       writeln('LA STRINGA RITRASFORMATA (UGUALE ALLA FRASE DI PARTENZA)'),
       writeln(Atom).


%            +------------------------------------------+
%            |              tokens                      |
%            +------------------------------------------+
       
tks:-
      Frase = 'Sono scesi in molti dalle case strette e alte di questa che fu la Suburra romana per dare l\'ultimo saluto al grande regista Monicelli',
      tokenize_atom(Frase, TokenList),
      writeln('Frase:'),
      writeln(Frase),nl,
      writeln('Tokens:'),
      writeln(TokenList).










       
         
         